<template>
    <Page>
        <StackLayout>
            <Label :text="score" textWrap="true" v-if="!avatar" />
            <Button text="Start the game" @tap="startGame()" v-if="!avatar" />
            <AbsoluteLayout>
                <Image v-if="avatar" :src="avatar" stretch="none" :top="position.y" :left="position.x" />
                <!-- <Label :text="position.x" textWrap="true" :top="position.y" :left="position.x" /> -->
                <!-- <Label :text="position.y" textWrap="true" /> -->
                <Image src="~/images/pierre.jpeg" stretch="none" :key="index" width="50" height="100" v-for="(obstacle, index) of obstacles" :left="obstacle.x" :top="obstacle.y" />
                <Label :text="obstacles.length" textWrap="true" />
            </AbsoluteLayout>
        </StackLayout>
    </Page>
</template>

<script>
import * as camera from "nativescript-camera";
import * as accelerometer from "nativescript-accelerometer";

export default {
    data() {
        return {
            avatar: null,
            position: {
                x: 200,
                y: 200
            },
            obstacles: [

            ],
            score: 0
        }
    },
    methods: {
        startGame() {
            camera.takePicture({ saveToGallery: false, width: 50, height: 100 }).then((image) => {
                this.avatar = image;
                accelerometer.startAccelerometerUpdates(coord => {
                    this.position.x += coord.x * 20;
                    this.position.y -= coord.y * 20;
                    // this.score++;
                    // console.log("x: " + data.x + "y: " + data.y + "z: " + data.z);
                    this.obstacles.forEach((obstacle, index) => {
                        obstacle.y += 2;
                        // platfr
                        if(this.isColliding(obstacle)){
                            this.score +=1000;
                            this.obstacles.splice(index, 1)
                        }
                    })

                }, { sensorDelay: "game" });
                setInterval(this.createObstacle, 2000);
            });
        },
        createObstacle() {
            this.obstacles.push({
                x: -100,
                y: Math.random(0, 500) * 200
            });
        },
        isColliding(obstacle) {
            return obstacle.x < this.position.x + 100 &&
                obstacle.x + 100 > this.position.x &&
                obstacle.y < this.position.y + 200 &&
                75 + obstacle.y > this.position.y;
        }
    },
}
</scriptù>

<style>
</style>
